/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   pipex.c                                            :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: erey-bet <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2023/01/18 18:04:58 by erey-bet          #+#    #+#             */
/*   Updated: 2023/03/07 16:22:34 by erey-bet         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "pipex.h"

int	free_all(t_data *data)
{
	int	i;
	int	y;

	if (data->fd1 > 0)
		close(data->fd1);
	close(data->fd2);
	y = -1;
	while (++y < data->argc - 3)
	{
		i = -1;
		while (data->flgs[y][++i])
			free(data->flgs[y][i]);
		free(data->flgs[y]);
	}
	free(data->flgs);
	i = -1;
	while (++i < data->argc - 3)
		free(data->cmds[i]);
	free(data->cmds);
	return (1);
}

void	make_cmd(t_data data, int i, int fl1, int fl2)
{
	if (fl1 > 0)
		dup2(fl1, 0);
	dup2(fl2, 1);
	close(data.fd[0][0]);
	close(data.fd[0][1]);
	if (i > 0)
	{
		close(data.fd[1][0]);
		close(data.fd[1][1]);
	}
	if (data.fd1 > 0)
		close(data.fd1);
	if (data.fd2 > 0)
		close(data.fd2);
	execve(data.cmds[i], data.flgs[i], data.env);
}

void	cmd(t_data data, int i, int t)
{
	if (t == 0)
		make_cmd(data, 0, data.fd1, data.fd[0][1]);
	else if (t == 1)
		make_cmd(data, i, data.fd[(i + 1) % 2][0], data.fd[i % 2][1]);
	else if (t == 2)
		make_cmd(data, i, data.fd[(i + 1) % 2][0], data.fd2);
	write(2, "Error execve\n", 13);
	free_all(&data);
	exit(1);
}

int	pipex(int argc, t_data data)
{
	int	*fk;
	int	i;

	fk = ft_calloc(argc - 3, sizeof(int));
	if (!fk)
		return (1);
	if (pipex_loop(argc, &fk, data))
		return (1);
	i = -1;
	while (++i < argc - 3)
		waitpid(fk[i], NULL, 0);
	free(fk);
	return (0);
}

int	main(int argc, char *argv[], char **env)
{
	t_data	data;

	if (argc < 5 || (!ft_strncmp(argv[1], "here_doc", 8) && argc < 6))
	{
		write(2, "Not enought argument\n", 21);
		return (1);
	}
	if (ft_strncmp(argv[1], "here_doc", 8) == 0)
	{
		argc = argc - 1;
		if (here_doc(argc, argv, env, &data))
			return (2);
	}
	else if (parsing(argc, argv, env, &data))
		return (3);
	data.argc = argc;
	if (verification_command(argv, data))
		return (4);
	if (pipex(argc, data))
		return (free_all(&data));
	free_all(&data);
	return (0);
}
